var doc = app.activeDocument;
var obj = doc.selection;
var mLayer= doc.activeLayer;
var newItem;
var i, sourceDoc, targetFile;
var destFolder = null;
var docSelected = doc.selection;
var mem = new Array();
var opt = new ExportOptionsPhotoshop();
var type = ExportType.PHOTOSHOP;
	opt.antiAliasing = true;	
	opt.resolution = 150;
	opt.embedICCProfile = true;
	opt.editableText = false;	
	opt.maximumEditability = false;
	opt.warnings = false;
	opt.writeLayers = false;
// CMYK Grayscale RGB
	opt.imageColorSpace = ImageColorSpace.RGB;

var optJPEG = new ExportOptionsJPEG();
var typeJPEG = ExportType.JPEG;
	optJPEG.antiAliasing = true;
// optimization for WEB
	optJPEG.optimization = true;
	optJPEG.qualitySetting = 100;

var PSD = true;

var bnd = new Array();
if (documents.length > 0){
	if (obj.length > 0) {
		bnd = getBounds(obj);	
		W = bnd[2] - bnd[0];
		H = bnd[1] - bnd[3];
		X = bnd[0];
		Y = bnd[1];
	}
	else {
		doc.rulerOrigin = Array(0, 0);
		bnd[0] = 0;
		bnd[2] = doc.width;
		bnd[1] = doc.height;
		bnd[3] = 0;
	}
	doc.cropBox = bnd;
	doc.cropStyle = CropOptions.Standard;
	var j=0;
	for (i=0; i<doc.layers.length; i++) {
		if (doc.layers[i].visible){
			doc.layers[i].visible = false;
		}
		else {
			mem[j] = i;
			j = j + 1;
		}
	}
	var mLayer= doc.layers.add();
	mLayer.zOrder(ZOrderMethod.SENDTOBACK);
	for (j=0; j < docSelected.length; j++) newItem = docSelected[j].duplicate(doc, ElementPlacement.PLACEATEND);
	
	destFolder = Folder.selectDialog( 'Select the folder where you want to save the exported files.', '~' );
	if (destFolder != null) {	
		targetFile = destFolder;
		if (PSD) doc.exportFile(targetFile, type, opt);
		else doc.exportFile(targetFile, typeJPEG, optJPEG);
	}
	mLayer.remove();
	j=0;	
	for (i=0; i<doc.layers.length; i++) {		
		doc.layers[i].visible = true;
	}
	for (i=0; i<mem.length; i++) {
		j = mem[i];
		doc.layers[j].visible = false;
	}	
}
function getBounds(obj) {
	var selObj1 = new Array();
	var selObj2 = new Array();
	var vgb1 = new Array();
	var vgb2 = new Array();
	var n = obj.length;
	if (n>0){		
		if( (obj[0].typename == 'GroupItem') && obj[0].clipped && (obj[0].pageItems.length > 1) ){
			clipObj = obj[0].pathItems[0].geometricBounds;
			vgb1 = clipObj;
		}
		else {
			selObj1 = obj[0];
			vgb1 = selObj1.visibleBounds;
		}
		if (n > 1) {
			for (i=1; i<n; i++) {
				selObj2 = obj[i];
				if( (obj[i].typename == 'GroupItem') && obj[i].clipped && (obj[i].pageItems.length > 1) ) {
					vgb2 = obj[i].pathItems[0].geometricBounds;
				}		
				else {
					vgb2 = selObj2.visibleBounds;
				}
				if( vgb1[0] > vgb2[0] ) vgb1[0] = vgb2[0];
				if( vgb1[1] < vgb2[1] ) vgb1[1] = vgb2[1];
				if( vgb1[2] < vgb2[2] ) vgb1[2] = vgb2[2];
				if( vgb1[3] > vgb2[3] ) vgb1[3] = vgb2[3];
			}
		}
	}
	return vgb1;
}
